<template>
    <MdTableRow v-bind:class="{'mark-sorted': markSortedColumn, [headerCls]: true, headerRow: true }">
        <MdTableCell v-bind:key="column.field" v-for="column in columns"
                     v-bind:class="{header: true, [column.className]: !!column.className,
                 sorteableHeader: column.sort,
                 empty: emptyRow,
                 marked: column.field && sortedColumn === column.field
        }"
        >
            <template v-if="column.sort">
                <div @click="clicked(column)">
                    <ArrowDown v-if="fieldSortedDescending(column.field)" />
                    <ArrowUp v-if="fieldSortedAscending(column.field)" />
                    {{column.label}}
                </div>
                <MdTooltip>{{sortTooltip(column)}}</MdTooltip>
            </template>
            <template v-else>{{column.label}}</template>
        </MdTableCell>
    </MdTableRow>
</template>
<script>
  import MdTooltip from '../TouchDeviceDisabledTooltip';
  import ArrowUp from 'vue-material-design-icons/ArrowUp.vue';
  import ArrowDown from 'vue-material-design-icons/ArrowDown.vue';
  import i18n from './i18n';

  /* eslint-disable no-debugger */

  export default {
    props: {
      columns: {
        type: Array,
        isRequired: true
      },
      ascending: {
        type: Boolean,
        isRequired: true
      },
      sortedColumn: {
        type: String
      },
      emptyRow: {
        type: Boolean,
        default: false
      },
      markSortedColumn: {
        type: Boolean,
        isRequired: true
      },
      headerClass: {
        type: String,
        isRequired: true,
        default: undefined
      }
    },
    i18n,
    components: { ArrowUp, ArrowDown, MdTooltip },
    computed: {
      headerCls(){
        if(this.headerClass) return this.headerClass;
        return 'defaultHeaderCls';
      }
    },
    methods: {
      clicked(column) {
        this.$emit('sort', column);
      },
      fieldSortedAscending(field) {
        if (field !== this.sortedColumn) return false;
        return this.ascending;
      },
      fieldSortedDescending(field) {
        if (field !== this.sortedColumn) return false;
        return !this.ascending;
      },
      sortTooltip({ label: column, field }) {
        const order = this.$t(field !== this.sortedColumn || !this.ascending ? 'ascending' : 'descending');
        return this.$t('sortTooltip', { column, order });
      }
    },
    data() {
      return {
        scroll: true
      }
    }
  }
</script>
<style scoped>
    .sorteableHeader {
        cursor: pointer;
    }

    .empty DIV {
        color: transparent;
        height: 0px;
        padding: 0;
    }

    .empty {
        height: 0px;
        visibility: hidden;
        position: fixed;
    }

    .header {
        font-weight: bold;
        color: black !important;
        display: table-cell;
        vertical-align: initial;
    }
    .mark-sorted .marked{
        background-color: var(--table-order-bg-color) !important;
    }
    .defaultHeaderCls{
        background-color: var(--md-theme-default-light-background);
    }
</style>
<style>
    .marked .md-table-head-label {
        padding-left: 8px;
    }
    .header > .md-table-cell-container {
        word-break: break-word;
    }
</style>
